<script type="text/javascript">
  (async function() {
    if (!window.dimXmlPromise) {
      const prom = {};
      prom.promise = new Promise((resolve) => (prom.resolve = resolve));
      window.dimXmlPromise = prom;
      /* will be resolved by DimXmlConf script */
    }

    const dimXml = await dimXmlPromise.promise;
    dimXml.utils.genNodeTemplate("dim-xml-dataset-server", {
      nodeName: {
        property: "name",
        label: RED._('node-red-dim-xml/disXmlDataSet:disXmlDataSet.label.node-name')
      },
      nodeConf: {
        property: "cnf",
        label: RED._('node-red-dim-xml/disXmlDataSet:disXmlDataSet.label.node-conf')
      },
      serviceName: {
        property: "serviceName",
        label: RED._('node-red-dim-xml/disXmlDataSet:disXmlDataSet.label.service-name')
      },
      orderedList: {
        label: RED._('node-red-dim-xml/disXmlDataSet:disXmlDataSet.label.ordered-list'),
      }
    });

    RED.nodes.registerType("dim-xml-dataset-server", {
      category: 'network',
      color: '#F38B68',
      defaults: {
        name: { value: "" },
        cnf: { type: "dim-xml-conf", required: true },
        serviceName: { value: "", required: true,
          validate: RED.validators.regex(disXml.regExp.srvName)
        },
        dataset: { value: [] }
      },
      icon: 'bridge.svg',
      inputs: 1,
      outputs: 1,
      label: function() {
        return dimXml.utils.getLabel(this, "DIM-XML DataSet Server");
      },
      oneditprepare: function() {
        const node = this;

        node._datasetList = disXml.editor.buildDataSetList(
          {
            firstValue: 0,
            indexWidth: '130px',
            unitWidth: '120px',
            indexLabel: node._('disXmlDataSet.label.ol-item.index'),
            nameLabel: node._('disXmlDataSet.label.ol-item.name'),
            unitLabel: node._('disXmlDataSet.label.ol-item.unit')
          });

        node._datasetList.load(node.dataset);
      },
      oneditsave: function() {
        this.dataset = this._datasetList.save();
      },
      oneditresize: dimXml.utils.resizeDialog
    });
  }());
</script>

<script type="text/html" data-template-name="dim-xml-dataset-server"></script>
